<template>
    <div class="recover">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                'pt-16',
            ]"
        >
            <v-col md="4" offset-md="4">
                <v-row>
                    <v-col class="pt-0 text-left">
                        <v-row>
                            <v-col class="pt-0">
                                <h2>
                                    {{ $t('common.recoverPassword') }}
                                </h2>
                            </v-col></v-row
                        >
                        <v-form
                            v-show="pageLoaded"
                            ref="recoverPasswordForm"
                            lazy-validation
                            @submit.prevent
                        >
                            <v-row>
                                <v-col>
                                    <v-col
                                        cols="12"
                                        class="form-field font-metropolis-regular pl-0"
                                    >
                                        <!-- EMAIL -->
                                        <v-text-field
                                            ref="email"
                                            v-model="form.email.value"
                                            :label="$t('form.email.text')"
                                            :placeholder="
                                                $t('form.email.placeholder')
                                            "
                                            solo
                                            :rules="[
                                                requiredRules,
                                                requiredEmail,
                                            ]"
                                            :error-messages="form.email.error"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" class="pa-0">
                                        <v-btn
                                            :block="
                                                $vuetify.breakpoint.smAndDown
                                            "
                                            :loading="loading"
                                            :disabled="loading"
                                            class="mt-5 lowercase br-0 pl-10 pr-10 font-syne-bold"
                                            color="badge"
                                            @click="validateForm"
                                            >{{ $t('common.send') }}</v-btn
                                        >
                                    </v-col>
                                    <v-col cols="12" class="pa-0">
                                        <v-btn
                                            text
                                            color="badge"
                                            class="lowercase pl-0"
                                            @click="goToPage(menus.SIGNIN.id)"
                                            >{{
                                                $t('common.rememberPassword')
                                            }}</v-btn
                                        >
                                    </v-col>
                                </v-col>
                            </v-row>
                        </v-form>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component<any>({
    middleware: ['authenticated'],
    head() {
        return {
            title: this.$t('common.recoverPassword'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenu',
    }),
})
export default class Recover extends Vue {
    // Data
    $refs!: { recoverPasswordForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    menus!: any
    loading: Boolean = false
    showPass: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        email: {
            value: '',
            error: null,
            requestKey: 'email',
        },
    }

    isButtonDisabled = false

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.SIGNIN.id:
                this.$router.push(this.menus.SIGNIN.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.recoverPasswordForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true
        this.loading = true
        this.$api.auth
            .recover(this.form.email.value)
            .then(() => {
                // Display snackbar
                const val = {
                    text: this.$t('snackbar.sendResetPasswordEmailSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Redirect
                this.$router.push('/')

                this.loading = false
            })
            .catch((error) => {
                if (error.response.status === 422) {
                    // Display snackbar
                    const val = {
                        text: this.$t('notification.password.invalidUser'),
                        color: 'white',
                        icon: 'mdi-information',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
                this.isButtonDisabled = false
                this.loading = false
            })
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }
}
</script>
